﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kompozyt
{
    public interface IOdwiedzający
    {
        void Odwiedź(Pracownik pracownik);
    }

    class OdwiedzającyWyświetlającyInformację : IOdwiedzający
    {
        public void Odwiedź(Pracownik pracownik)
        {
            Console.WriteLine(pracownik.ToString());
        }
    }

    class OdwiedzającyZliczający : IOdwiedzający
    {
        public int Licznik { get; private set; }

        public void Odwiedź(Pracownik pracownik)
        {
            Licznik++;
        }
    }

    class OdwiedzającySpłaszczający : IOdwiedzający
    {
        public List<Pracownik> Lista { get; private set; } = new List<Pracownik>();

        public void Odwiedź(Pracownik pracownik)
        {
            Lista.Add(pracownik);
        }
    }
}
